<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  type JsonFormsSubStates,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import every from "lodash/every";
import isArray from "lodash/isArray";
import isString from "lodash/isString";
import { defineComponent } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "ncbi-taxon-id-control-renderer",
  /* eslint-enable */
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    // For information, if you want to change data in control, you must use control.handleChange()
    const search = ref();
    const loading = ref();
    const jsonforms = inject<JsonFormsSubStates>("jsonforms");

    function handle(value) {
      control.handleChange("taxonID", value);
    }
    return { ...control, loading, search, jsonforms, handle };
  },
  computed: {
    suggestions(): string[] | undefined {
      const suggestions = this.control.uischema.options?.suggestion;

      if (suggestions === undefined || !isArray(suggestions) || !every(suggestions, isString)) {
        // check for incorrect data
        return undefined;
      }
      return suggestions;
    },
  },
  watch: {
    control(value, oldValue) {
      if (
        "scientificName" in this.jsonforms.core.data
        && this.jsonforms.core.data.scientificName.includes("::")
      ) {
        const newVal = this.jsonforms.core.data.scientificName.split(":")[0];
        if (newVal !== oldValue.data || value.data === undefined) {
          this.handle(newVal);
          this.control.value = newVal;
          this.control.data = newVal;
        }
      }
    },
  },
});

export default controlRenderer;
export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("ncbi-taxon-id"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :is-focused="isFocused"
    :applied-options="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-text-field
        :id="`${control.id}-input`"
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :model-value="control.data"
        :maxlength="appliedOptions.restrict ? control.schema.maxLength : undefined"
        :counter="control.schema.maxLength !== undefined ? control.schema.maxLength : undefined"
        :clearable="isHovering"
        v-bind="vuetifyProps('v-text-field')"
        @update:model-value="onChange"
        @focus="handleFocus"
        @blur="handleBlur"
      />
    </VHover>
  </ControlWrapper>
</template>
